package net.sourceforge.iriverter;

import org.eclipse.swt.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.graphics.*;

public class ExtraOptionsDialog extends Dialog implements SelectionListener {
	private String extraOptions;
	private Shell shell;
	private Text extraOptionsInput;
	private Button dismiss;
	
	public ExtraOptionsDialog(Shell parent, int style, String extraOptions) {
		super(parent, style);
		this.extraOptions = extraOptions;
	}
	
	public String open() {
		shell = new Shell(getParent(), SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
		shell.setText("Extra Options");
		GridLayout gridLayout = new GridLayout();
		gridLayout.horizontalSpacing = 6;
		gridLayout.verticalSpacing = 6;
		gridLayout.marginHeight = 12;
		gridLayout.marginWidth = 12;
		shell.setLayout(gridLayout);
		
		Label extraOptionsLabel = new Label(shell, SWT.NONE);
		extraOptionsLabel.setText("Extra Options");
		FontData[] fontData = extraOptionsLabel.getFont().getFontData();
		fontData[0].setStyle(SWT.BOLD);
		extraOptionsLabel.setFont(new Font(getParent().getDisplay(), fontData));
		
		extraOptionsInput = new Text(shell, SWT.BORDER);
		extraOptionsInput.setText(extraOptions);
		extraOptionsInput.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		
		dismiss = new Button(shell, SWT.PUSH);
		dismiss.setText("Close");
		GridData gridData = new GridData();
		gridData.widthHint = 75;
		gridData.horizontalAlignment = SWT.RIGHT;
		dismiss.setLayoutData(gridData);
		dismiss.addSelectionListener(this);
		
		shell.pack();
		shell.setSize(400, shell.getSize().y);
		
		shell.open();
		while (!shell.isDisposed())
			if (!getParent().getDisplay().readAndDispatch())
				getParent().getDisplay().sleep();
		
		return extraOptions;
	}
	
	public void widgetDefaultSelected(SelectionEvent e) {
		// empty
	}
	
	public void widgetSelected(SelectionEvent e) {
		if (e.getSource() == dismiss || e.getSource() == extraOptionsInput) {
			extraOptions = extraOptionsInput.getText();
			shell.dispose();
		}
	}
}
